<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Linked List</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Linked List</h1>    
                    </section>
                    <section>
                        <h2>Linked List Overview</h2>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                    </section>
                </section>
                <!-- Statements and Blocks Section -->
                <section>   
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Defining Linked Lists</h2>
						<p>Linked lists are the best and simplest example of a dynamic data structure that uses pointers for its implementation</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>What is a linked list?</h2>
						<p>A linked list is a set of dynamically allocated nodes, arranged in such a way that each node contains one value and one pointer</p>
						<img src="../../../assets/LLnode.jpg" alt="LinkedList1">
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                </section>
                <!-- If Statements Section -->
                <section>
                    <section>
                        <h2>Singly Linked list</h2>
						<img src="../../../assets/linkedlist2.jpg" alt="LinkedList2">
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Pointing in Linked Lists </h2>
						<img src="../../../assets/linkedlist3.jpg" alt="LinkedList3">
					</section>
					<section>
						<h2>Defining the node </h2>
						<pre>
							<code data-trim data-noescape>
							struct node {
								int num;
								struct node *next;
							 };
						</code>
						</pre>
						<p>or use typedef</p>
						<pre>
							<code data-trim data-noescape>
								typedef struct node {
									int num;
									struct node *next;
								 } Node, *NodePtr; // we also declare a name for "struct node *"
						</code>
						</pre>
						
					</section>
					<section>
						<h2>Variable Top </h2>
						<pre>
							<code data-trim data-noescape>
								Node *top;
						</code>
						</pre>
						<p>or this</p>
						<pre>
							<code data-trim data-noescape>
								NodePtr top;
							</code>
						</pre>
						
					</section>
					<section>
						<h2>Basic Operations on a LinkedList</h2>

					</section>
					<section>
						<h3>Counting Nodes in a LinkedList</h3>
						<pre>
							<code data-trim data-noescape>
								NodePtr curr = top;
								while (curr != NULL) curr = curr -> next;
							</code>
						</pre>
					</section>
					<section>
						<p>Initially, curr points to the first item, if any, 
							in the list. If it is not NULL, the following statement is executed:</p>
						<pre>
							<code data-trim data-noescape>
								curr = curr -> next;
							</code>
						</pre>
					</section>
					<section>
						<img src="../../../assets/linkelist4.jpg" alt="LinkedList4">
					</section>
					<section>
						<p>Implementing a Counter</p>
						<pre>
							<code data-trim data-noescape>
								int length(NodePtr top) {
									int n = 0;
									NodePtr curr = top;
									while (curr != NULL) {
									   n++;
									   curr = curr -> next;
									}
									return n;
								 } //end length
							</code>
						</pre>
					</section>
                </section>
                <!-- if/else Statments Section -->
                <section>
                    <section>
							<h3>Searching a Linked list</h3>
		
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Another common operation is to search a linked list for a given item</h2>
						<p>Search for number 52</p>
						<img src="../../../assets/linkedlist5.jpg" alt="LinkedList5">
					</section>
					<section>
						<p>We must write the logic so that the search 
							ends if we find a match or we reach the end of the list</p>
							<pre>
								<code data-trim data-noescape>
									while (curr != NULL && key != curr -> num) curr = curr -> next;
								</code>
							</pre>
					</section>
					<section>
						<p>Writing a search function</p>
							<pre>
								<code data-trim data-noescape>
									NodePtr search(NodePtr top, int key) {
										while (top != NULL && key != top -> num)
										   top = top -> next;
										return top;
									 } //end search
								</code>
							</pre>
					</section>
                </section>
                <!-- else/if Statements Section -->
                <section>
                    <section>
                        <h2>Finding the Last Node in a Linked List</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>Getting the last node</p>
                        <pre>
							<code data-trim data-noescape>
								NodePtr getLast(NodePtr top) {
									if (top == NULL) return NULL;
									while (top -> next != NULL)
									   top = top -> next;
									return top;
								 } //end getLast
							</code>
						</pre>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                </section>
                <!-- switch Statements Section -->
                <section>
                    <section>
                        <h2> Dynamic Storage Allocation: malloc, calloc, sizeof, free</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>consider the following data </h2>
						<pre>
							<code data-trim data-noescape>
								36 15 52 23 0
							</code>
						</pre>
					</section>
					<section>
						<p>Say we want to build the following linked list:</p>
						<img src="../../../assets/linkedlist6.jpg" alt="LinkedList6">

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>In C, storage can be allocated dynamically by using the standard functions malloc and calloc. In order to use these functions (and free, later), 
							your program must be preceded by this header line</p>
						<pre>
							<code data-trim data-noescape>
								#include stdlib.h
							</code>
						</pre>
					</section>
					<section>
						<p>It is a fatal error to attempt to free storage not obtained by a call to malloc or calloc, 
							using pointers to memory that has been freed and freeing pointers twice.</p>
					</section>
                </section>
                <!-- Loops Section -->
                <section>
                    <section>
                        <h2>Building a Linked list: 
							Adding New item at the tail
						</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>building a linked list of positive integers in the order in which they are given</h2>
						<pre>
							<code data-trim data-noescape>
								36 15 52 23 0
							</code>
						</pre>
					</section>
					<section>
						<p>And say we want to build the following linked list:</p>
						<img src="../../../assets/linkedlist7.jpg" alt="LinkedList7">

					</section>
					<section>
						<p>we start with an empty list. 
							Our program will reflect this with the following statement</p>
							<pre>
								<code data-trim data-noescape>
									top = NULL;
								</code>
							</pre>
					</section>
					<section>
						<h3>When we read a new number, we must do the following:</h3>
						<ul>
							<li>Allocate storage for a node</li>
							<li>Put the number in the new node</li>
							<li>Make the new node the last node in the list</li>
						</ul>
					</section>
					<section>
						<p> assume the following declaration for defining a node</p>
							<pre>
								<code data-trim data-noescape>
									typedef struct node {
										int num;
										struct node *next;
									 } Node, *NodePtr;
								</code>
							</pre>
					</section>
					<section>
						<p> Let’s write a function called makeNode</p>
							<pre>
								<code data-trim data-noescape>
									NodePtr makeNode(int n) {
										NodePtr np = (NodePtr) malloc(sizeof (Node));
										np -> num = n;
										np -> next = NULL;
										return np;
									 }
								</code>
							</pre>
							<p>Consider the following call:</p>
							<pre>
								<code data-trim data-noescape>
									makeNode(36);
								</code>
							</pre>
					</section>
					<section>
						<p>First, storage for a new node is allocated</p>
						<img src="../../../assets/linkedlist8.jpg" alt="LinkedList8">
						<p>makeNode then stores 36 
							in the num field and NULL in the next field, giving us this:</p>
							<img src="../../../assets/linkedlist9.jpg" alt="LinkedList9">
						<p>The value 4000 is then returned by makeNode.</p>
					</section>
					<section>
						<p>When we read the first number, we must create a node for it and set top to point to the new node. 
							In our example, when we read 36, we must create the following:</p>
							<img src="../../../assets/linkedlist10.jpg" alt="LinkedList10">
					</section>
					<section>
						<p>If n contains the new number, this can be accomplished with a statement such as this:</p>
						<pre>
							<code data-trim data-noescape>
								if (top == NULL) top = makeNode(n);
							</code>
						</pre>
					</section>
					<section>
						<p>From the previous example, makeNode returns 4000, 
							which is stored in top. Effectively, top now “points to” the node containing 36.</p>
					</section>
					<section>
						<img src="../../../assets/linkedlist11.jpg" alt="linkedlist11">
					</section>
					<section>
						<p>For each subsequent number, we must set the next field of the current last node to point to the new node. 
							The new node becomes the last node.</p>
					</section>
					<section>
						<img src="../../../assets/linkedlist12.jpg" alt="linkedlist12">
					</section>
                </section>
                <!-- while Loops Section -->
                <section>
                    <section>
                        <h2>Insertion into a Linked List</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<img src="../../../assets/linkedlist13.jpg" alt="linkedlist13">
					</section>
					<section>
						<p>Insertion</p>
						<pre>
							<code data-trim data-noescape>
								np -> next = prev -> next;
								prev -> next = np;
							</code>
						</pre>
					</section>
					<section>
						<p>The net effect is that the new node is inserted between the second and the third.</p>
						<img src="../../../assets/linkedlist14.jpg" alt="linkedlist14">
					</section>
					<section>
					<p>In many situations, it is required to insert a new node at the head of the list</p>
					<img src="../../../assets/linkedlist15.jpg" alt="linkedlist15">
					<p>to this:</p>
					<img src="../../../assets/linkedlist16.jpg" alt="linkedlist16">
					<p>This can be done with the code: </p>
					<pre>
					<code data-trim data-noescape>
						np -> next = top;
						top = np;
					</code>
				</pre>

					</section>
                </section>
                <!-- do while Loops Section -->
                <section>
                    <section>
                        <h2>Building a Linked List: Adding a New Item at the Head</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2> Say the incoming numbers are as follows (0 terminates the data):</h2>
						<p>And say we want to build the following linked list:</p>
						<img src="../../../assets/linkedlist17.jpg" alt="linkedlist17">
						
					</section>
					<section>
						<p>The previous program and this one are identical except for the main function which has changes
							in the while loop
						</p>
						<pre>
							<code data-trim data-noescape>
								//add new numbers at the head of the list
								int main() {
								   void printList(NodePtr);
								   NodePtr makeNode(int);
								   int n;
								   NodePtr top, np;
								   top = NULL;
								   if (scanf("%d", &n) != 1) n = 0;
								   while (n != 0) {
									  np = makeNode(n);   //create a new node containing n
									  np -> next = top;   //set link of new node to first node
									  top = np;   //set top to point to new node
									  if (scanf("%d", &n) != 1) n = 0;
								   }
								   printList(top);
								} //end main
							</code>
						</pre>
					</section>
                </section>
                <!-- Break Section -->
                <section>
                    <section>
                        <h2>Deletion from a Linked list</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <p>Deleting a node from the top of a linked list is accomplished by doing this
						</p>
						<pre>
							<code data-trim data-noescape>
								top = top -> next;
							</code>
						</pre>
					</section>
					<section>
						<p>In many situations, it is required to insert a new node at the head of the list</p>
						<img src="../../../assets/linkedlist18.jpg" alt="linkedlist18">
						<p>to this:</p>
						<img src="../../../assets/linkedlist19.jpg" alt="linkedlist19">
						
	
						</section>
						<section>
							<p>Then deletion of node curr can be accomplished by doing this:</p>
							<img src="../../../assets/LinkedlistDel1.png" alt="linkedlist20">
							<p>to this:</p>
							<img src="../../../assets/LinkedlistDel2.png" alt="linkedlist21">
							<p>This can be done with the code: </p>
							<pre>
							<code data-trim data-noescape>
								prev -> next = curr -> next;
							</code>
						</pre>
		
							</section>
					 <section>
						 <p>To illustrate its use, deleting the first node of the list can be accomplished by doing the following, 
							 where old is the same kind of pointer as top:</p>
							 <pre>
								<code data-trim data-noescape>
									old = top;          // save the pointer to the node to be deleted
									top = top -> next;  // set top to point to the 2nd node, if any
									free(old);          // free the space occupied by the first node
															</code>
							</pre>
					 </section>
					 <section>
						<p>To delete a node from elsewhere in the list where curr points to the node to
							 be deleted and prev points to the previous node, we can use this:</p>
							<pre>
							   <code data-trim data-noescape>
								prev -> next = curr -> next; // logical deletion
								free(curr);                  // free the space occupied by the deleted node
								</code>
						   </pre>
					</section>
                </section>
                <!-- Nested Control Flow Section -->
                <section>
                    <section>
                        <h2>Free Statement</h2>
						<section>
							<p>The free statement will change the following:</p>
							<img src="../../../assets/linkedlist22.jpg" alt="linkedlist22">
							<p>to this:</p>
							<img src="../../../assets/linkedlist23.jpg" alt="linkedlist23">
							<p>This can be done with the code: </p>
							<pre>
							<code data-trim data-noescape>
								prev -> next = curr -> next;
							</code>
						</pre>
		
							</section>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Linked list Demos </h2>
                    </section>
                </section>
 
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>List</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
